public class Grid {
	public static Arquivo arquivo;
	private char[][] grid;
	private char c;
	
	public Grid(int n) {
		grid = new char[n][];
		for (int i = 0; i < n; i++)
			grid[i] = arquivo.readLine().toCharArray();
		for (int i = 0; i < grid.length; i++)
			for (int j = 0; j < grid[i].length; j++)
				if (grid[i][j] != ' ') {
					c = grid[i][j];
					return;
				}				
	}
	
	public void fill() {
		for (int i = 0; i < grid.length; i++)
			for (int j = 0; j < grid[i].length; j++)
				if (grid[i][j] != ' ' && grid[i][j] != c) {
					fill(i+1, j, grid[i][j]);
					fill(i-1, j, grid[i][j]);
					fill(i, j+1, grid[i][j]);
					fill(i, j-1, grid[i][j]);
				}
				
	}
	
	private void fill(int i, int j, char c) {
		if (grid[i][j] != ' ')
			return;
		else {
			grid[i][j] = c;
			fill(i+1, j, c);
			fill(i-1, j, c);
			fill(i, j+1, c);
			fill(i, j-1, c);
		}
		
		
	}
	
	public void print() {
		for (int i = 0; i < grid.length; i++) {
			for (int j = 0; j < grid[i].length; j++)
				arquivo.print(grid[i][j]);
			arquivo.println();
		}	
	}
	
	public static void main(String[] args) {
		arquivo = new Arquivo("grid.in", "grid.out");
		int fig = 1;
				
		while (!arquivo.isEndOfFile()) {
			int n = arquivo.readInt();
			arquivo.readLine();
			
			Grid grid = new Grid(n);
			grid.fill();
			
			arquivo.println("Figura " + fig + ":");
			grid.print();
			arquivo.println();
			fig++;
		}
		arquivo.close();
	}	
}
